#ifndef _ROS_openlab_RF_h
#define _ROS_openlab_RF_h

#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include "ros/msg.h"

namespace openlab
{

  class RF : public ros::Msg
  {
    public:
      typedef int32_t _encoder_1_type;
      _encoder_1_type encoder_1;
      typedef int32_t _encoder_2_type;
      _encoder_2_type encoder_2;
      typedef int32_t _encoder_3_type;
      _encoder_3_type encoder_3;
      typedef int32_t _encoder_4_type;
      _encoder_4_type encoder_4;

    RF():
      encoder_1(0),
      encoder_2(0),
      encoder_3(0),
      encoder_4(0)
    {
    }

    virtual int serialize(unsigned char *outbuffer) const
    {
      int offset = 0;
      union {
        int32_t real;
        uint32_t base;
      } u_encoder_1;
      u_encoder_1.real = this->encoder_1;
      *(outbuffer + offset + 0) = (u_encoder_1.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_encoder_1.base >> (8 * 1)) & 0xFF;
      *(outbuffer + offset + 2) = (u_encoder_1.base >> (8 * 2)) & 0xFF;
      *(outbuffer + offset + 3) = (u_encoder_1.base >> (8 * 3)) & 0xFF;
      offset += sizeof(this->encoder_1);
      union {
        int32_t real;
        uint32_t base;
      } u_encoder_2;
      u_encoder_2.real = this->encoder_2;
      *(outbuffer + offset + 0) = (u_encoder_2.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_encoder_2.base >> (8 * 1)) & 0xFF;
      *(outbuffer + offset + 2) = (u_encoder_2.base >> (8 * 2)) & 0xFF;
      *(outbuffer + offset + 3) = (u_encoder_2.base >> (8 * 3)) & 0xFF;
      offset += sizeof(this->encoder_2);
      union {
        int32_t real;
        uint32_t base;
      } u_encoder_3;
      u_encoder_3.real = this->encoder_3;
      *(outbuffer + offset + 0) = (u_encoder_3.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_encoder_3.base >> (8 * 1)) & 0xFF;
      *(outbuffer + offset + 2) = (u_encoder_3.base >> (8 * 2)) & 0xFF;
      *(outbuffer + offset + 3) = (u_encoder_3.base >> (8 * 3)) & 0xFF;
      offset += sizeof(this->encoder_3);
      union {
        int32_t real;
        uint32_t base;
      } u_encoder_4;
      u_encoder_4.real = this->encoder_4;
      *(outbuffer + offset + 0) = (u_encoder_4.base >> (8 * 0)) & 0xFF;
      *(outbuffer + offset + 1) = (u_encoder_4.base >> (8 * 1)) & 0xFF;
      *(outbuffer + offset + 2) = (u_encoder_4.base >> (8 * 2)) & 0xFF;
      *(outbuffer + offset + 3) = (u_encoder_4.base >> (8 * 3)) & 0xFF;
      offset += sizeof(this->encoder_4);
      return offset;
    }

    virtual int deserialize(unsigned char *inbuffer)
    {
      int offset = 0;
      union {
        int32_t real;
        uint32_t base;
      } u_encoder_1;
      u_encoder_1.base = 0;
      u_encoder_1.base |= ((uint32_t) (*(inbuffer + offset + 0))) << (8 * 0);
      u_encoder_1.base |= ((uint32_t) (*(inbuffer + offset + 1))) << (8 * 1);
      u_encoder_1.base |= ((uint32_t) (*(inbuffer + offset + 2))) << (8 * 2);
      u_encoder_1.base |= ((uint32_t) (*(inbuffer + offset + 3))) << (8 * 3);
      this->encoder_1 = u_encoder_1.real;
      offset += sizeof(this->encoder_1);
      union {
        int32_t real;
        uint32_t base;
      } u_encoder_2;
      u_encoder_2.base = 0;
      u_encoder_2.base |= ((uint32_t) (*(inbuffer + offset + 0))) << (8 * 0);
      u_encoder_2.base |= ((uint32_t) (*(inbuffer + offset + 1))) << (8 * 1);
      u_encoder_2.base |= ((uint32_t) (*(inbuffer + offset + 2))) << (8 * 2);
      u_encoder_2.base |= ((uint32_t) (*(inbuffer + offset + 3))) << (8 * 3);
      this->encoder_2 = u_encoder_2.real;
      offset += sizeof(this->encoder_2);
      union {
        int32_t real;
        uint32_t base;
      } u_encoder_3;
      u_encoder_3.base = 0;
      u_encoder_3.base |= ((uint32_t) (*(inbuffer + offset + 0))) << (8 * 0);
      u_encoder_3.base |= ((uint32_t) (*(inbuffer + offset + 1))) << (8 * 1);
      u_encoder_3.base |= ((uint32_t) (*(inbuffer + offset + 2))) << (8 * 2);
      u_encoder_3.base |= ((uint32_t) (*(inbuffer + offset + 3))) << (8 * 3);
      this->encoder_3 = u_encoder_3.real;
      offset += sizeof(this->encoder_3);
      union {
        int32_t real;
        uint32_t base;
      } u_encoder_4;
      u_encoder_4.base = 0;
      u_encoder_4.base |= ((uint32_t) (*(inbuffer + offset + 0))) << (8 * 0);
      u_encoder_4.base |= ((uint32_t) (*(inbuffer + offset + 1))) << (8 * 1);
      u_encoder_4.base |= ((uint32_t) (*(inbuffer + offset + 2))) << (8 * 2);
      u_encoder_4.base |= ((uint32_t) (*(inbuffer + offset + 3))) << (8 * 3);
      this->encoder_4 = u_encoder_4.real;
      offset += sizeof(this->encoder_4);
     return offset;
    }

    const char * getType(){ return "openlab/RF"; };
    const char * getMD5(){ return "72ef78eb5e9bafb28f2bd3ab6be8a6a5"; };

  };

}
#endif
